# 挥码枪上手常见问题
挥码枪是基于JTAG技术的硬件调试器，刚开始使用时有一些门槛，对于和笔者一样的萌新小白，遇到些问题没关系。本文将常见的问题归纳出来，教大家如何解决。
当您初次使用挥码枪和GDK8时，最常见的问题就是下图这样的连接故障。


![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_9cd7227b341003db3a525681e88d7a9c_r.png)
## 两种原因
导致连接失败的典型原因有如下两个：
原因1：没有切到JTAG模式
原因2：线路不通

------------
## 原因1
原理：GDK8的SD口本来是用来读写SD卡的，要进行内核调试时，需要切换到调试模式（JTAG模式）
操作：切换到调试模式的方法有多种，最简单的方法是使用遥控器。**FN+5**就是切换SD接口模式的指令。切换成功后LED屏幕的反馈如下图，显示F5 01。此时GDK8就开始进入JTAG模式了。
注意：（***这里强调一下不是二者一起按！而是先FN，后5，二者的间隔只要不是太长，就可以成功。笔者自己尝试，单手和双手操作的时间间隔都在可以响应的范围内。***）

![之前](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_6f88878705662f8968d5a36c914b02ed_r.png "之前")

![之后](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_f891f6bbeb070fed5956b2b0897cd791_r.png "之后")

出现如上图所示的变化就代表成功了

------------
## 原因2

- 如果您按照提示按了**Fn+5**之后依然不能解决问题，接下来您可以看一下挥码枪和GDK8的连接是否牢靠，有可能是硬件的连接问题导致的。尝试重新插拔一下。（不用重启电脑等操作，直接插拔就可以）。建议您操作时，把GDK8放稳，将转接头弹出，再次插入。

插拔一下下图所示的转接头：
![](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_b6ec043581b1fae921f6cf56dfcdfd9c_r.png "拔插一下这里")

## 总结 

认真检查以上两个原因后，重新打开Nano Code，再试一次内核调试，一般就会成功了。如果还没有，您应该检查Nano Code软件是否是比较新的版本，如果版本很老，建议您立刻更新。

------------
在尝试的时候，如果需要重新启动GDK8，那么只要拔掉电源，停顿大约1秒之后再接上即可。
![拔插一下这里](https://www.nanocode.cn/wiki/uploads/ndb_usages/images/m_61df6a8b08f8c14d39f662e638829157_r.png "拔插一下这里")